%decomposes a 3x4 camera matrix P into K,R,t such that P = K*[R -R*C]
function [K, R, t] = dm_KR_from_P(P, noscale)

N = size(P,1);
H = P(:,1:N);

[K,R] = rq(H);

cam_affine = K(N,N) == 0;

%if nargin < 2
  if ~cam_affine
    K = K / abs(K(N,N));
  else
    K = K / abs(K(N-1,N-1));
  end
  if K(1,1) < 0
    D = diag([-1 -1 ones(1,N-2)]);
    K = K * D;
    R = D * R;
    
  %  test = K*R; 
  %  dm_assert0(test/test(1,1) - H/H(1,1), 1e-07)
  end
  
  if K(2,2) < 0
    D = diag([1 -1 -1]);
    K = K * D;
    R = D * R;
  end
  
%end

if nargout > 2
  if ~cam_affine
    t = -P(:,1:N)\P(:,end);
  else
    t = -P(1:end-1,1:N)\P(1:end-1,end);
  end
end
